/******************************************************************************
 *
 * Copyright (c) 1999	TOSHIYUKI ARAI. ALL RIGHTS RESERVED. 
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions, and the following disclaimer.
 *  
 * 2. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *
 *	ObjectArray.cpp
 *
 *****************************************************************************/

// SOL++2000

#include <sol\ObjectArray.h> 


ObjectArray::ObjectArray(UINT size)
		:Array(size) 
{
	array = new Object*[size];
	for(UINT i = 0; i<size; i++) {
		array[i] = NULL;
	}
}


ObjectArray::~ObjectArray() 
{
	delete [] array;
}


BOOL ObjectArray::set(UINT n, Object* object)
{
	BOOL rc = FALSE;
	if(n <getSize()) {
		array[n] = object;	
		rc = TRUE;
	}
	return rc;
}


Object* ObjectArray::get(UINT n) 
{
	Object* object = NULL;
	if(n < getSize()) {
		object = array[n];
	}
	return object;
}


void ObjectArray::sort(SortDirection dir)
{
	int length = getSize();

	for (int i = 0; i<length -1; i++) {
		int j = i+1;
		Object*  obj = array[i];
		int  c = 0;
		for(j = i+1; j<length; j++) {
			Object* jthObj = array[j];
			if (dir == ASCENDING) {
				if (jthObj -> compare(obj) > 0) {
					c = j;
					obj = array[j];
				}	
			}
			if (dir == DESCENDING) {
				if (jthObj -> compare(obj) < 0) {
					c = j;
					obj = array[j];
				}	
			}
		}

		array[c] = array[i];
		array[i] = obj;
	}	
}

